Medusa = {
    -- Main info
    name = "Medusa",
    version = "1.6.3",
    author = "@Aaxc",
    language = "en",
    characterId = GetCurrentCharacterId(),
    difficulty = 0,

    -- Assistance settings
    inCombat = false,
    location = GetMapName(),
    debug = false,
    debugInfo = "",
    debugTime = 0,
    logStarted = false,

    stormFury = 0,
    bossLanding = 0,

    -- Variable data
    variableVersion = 3,
    Default = {
        kiteWidth = 350,
        emberstormShow = true,
        lockBars = true,
        focusedFireWindowOffsetX = 1550,
        focusedFireWindowOffsetY = 595,
        emberstormWindowOffsetX = 1550,
        emberstormWindowOffsetY = 645,
        cataclysmWindowOffsetX = 1550,
        cataclysmWindowOffsetY = 695,
        MedusaWindowOffsetX = 1120,
        MedusaWindowOffsetY = 600,
        fireStormWindowOffsetY = 600,
        fireStormWindowOffsetX = 715,
        emberstormWidth = 350,
        KiteWindowOffsetX = 1700,
        KiteWindowOffsetY = 350,
        PortalWindowOffsetX = 1700,
        PortalWindowOffsetY = 400,
        BigPortalWindowOffsetY = 350,
        BigPortalWindowOffsetX = 980,
        BigPortalWindowLocation = 3,
        Location = 128,
        fireStormHeight = 40,
        kiteHeight = 40,
        KiteWindowLocation = 3,
        OffsetX = -175,
        showKite = true,
        MedusaWindowLocation = 3,
        focusedFireShow = true,
        gravechillShow = true,
        timeShiftShow = true,
        kiteColor = {
            [1] = 0.2901960909,
            [2] = 0.0745098069,
            [3] = 0.5490196347,
            [4] = 1,
        },
        FocusedFireWindowLocation = 3,
        fireStormShow = true,
        cataclysmShow = true,
        showVeteran = false,
        PortalWindowLocation = 3,
        focusedFireColor =
        {
            [1] = 1,
            [2] = 0.7803921700,
            [3] = 0.2745098174,
            [4] = 1,
        },
        CloudrestLockBar = false,
        OffsetY = -150,
        cataclysmColor =
        {
            [1] = 1,
            [2] = 0.4352941176,
            [3] = 0,
            [4] = 1,
        },
        cataclysmWindowLocation = 3,
        cataclysmWidth = 350,
        cataclysmHeight = 40,
        emberstormColor =
        {
            [1] = 0.5333333611,
            [2] = 0.0509803928,
            [3] = 0.3058823645,
            [4] = 1,
        },
        fireStormWindowLocation = 3,
        fireStormWidth = 350,
        emberstormWindowLocation = 3,
        lockBar = true,
        emberstormHeight = 40,
        focusedFireHeight = 40,
        version = 3,
        kiteShow = true,
        focusedFireWidth = 350,
        SunspireLockBar = false,

        gravechillColor =
        {
            [1] = 0.098039,
            [2] = 0.462745,
            [3] = 0.823529,
            [4] = 1,
        },
        timeShiftColor =
        {
            [1] = 0.4862745,
            [2] = 0.7019607,
            [3] = 0.2588235,
            [4] = 1,
        },
        timeShiftWindowLocation = 3,
        timeShiftWidth = 350,
        timeShiftHeight = 40,
        timeShiftWindowOffsetY = 600,
        timeShiftWindowOffsetX = 715,
    },

    -- Zone IDs
    TRIAL_HEL_RA_CITADEL = 636,
    TRIAL_AETHERIAN_ARCHIVE = 638,
    TRIAL_SANCTUM_OPHIDIA = 639,
    TRIAL_DRAGONSTAR_ARENA = 635,
    TRIAL_MAW_OF_LORKHAJ = 725,
    TRIAL_MAELSTROM_ARENA = 677,
    TRIAL_HALLS_OF_FABRICATION = 975,
    TRIAL_ASYLUM_SANCTORIUM = 1000,
    TRIAL_CLOUDREST = 1051,
    TRIAL_BLACKROSE_PRISON = 1082,
    TRIAL_SUNSPIRE = 1121,

    -- Combat exit timer
    exitCombat = 0
}

-------------------------------------------------------------------------------------------------
-- Initialize Medusa --
-------------------------------------------------------------------------------------------------
function Medusa:Initialize()
    -- Set combat state
    Medusa.inCombat = IsUnitInCombat("player")

    -- Load langauge strings
    Medusa.Language = Medusa.GetLanguage()

    -- Load saved savedVariables
    Medusa.savedVariables = ZO_SavedVars:NewAccountWide("MedusaVars", Medusa.variableVersion, nil, Medusa.Default)

    -- Set default value
    if Medusa.savedVariables.showVeteran ~= false then
        Medusa.savedVariables.showVeteran = true
    end

    -- Adds settings menu
    Medusa.CreateSettingsWindow()

    -- Position Portal timer and hide for now
    PortalWindow:ClearAnchors()
    PortalWindow:SetAnchor(TOPLEFT, GuiRoot, Medusa.savedVariables.PortalWindowLocation, Medusa.savedVariables.PortalWindowOffsetX, Medusa.savedVariables.PortalWindowOffsetY)
    PortalWindow:SetHidden(true)

    -- Position Portal timer and hide for now
    BigPortalWindow:ClearAnchors()
    BigPortalWindow:SetAnchor(TOPLEFT, GuiRoot, Medusa.savedVariables.BigPortalWindowLocation, Medusa.savedVariables.BigPortalWindowOffsetX, Medusa.savedVariables.BigPortalWindowOffsetY)
    BigPortalWindow:SetHidden(true)

    -- Position Kite timer and hide for now
    KiteWindow:ClearAnchors()
    KiteWindow:SetHidden(true)
    KiteWindow:SetAnchor(TOPLEFT, GuiRoot, Medusa.savedVariables.KiteWindowLocation, Medusa.savedVariables.KiteWindowOffsetX, Medusa.savedVariables.KiteWindowOffsetY)
    KiteWindowStatusBar:SetColor(unpack(Medusa.savedVariables.kiteColor))
    Medusa.KiteSetBarSize(Medusa.savedVariables.kiteWidth, Medusa.savedVariables.kiteHeight)

    -- Position and color Sunspire Focused Fire
    Medusa.Sunspire.ActivateBars()
    Medusa.Sunspire.ShowBars(false)

    EVENT_MANAGER:UnregisterForEvent(Medusa.name, EVENT_ADD_ON_LOADED)
end

-------------------------------------------------------------------------------------------------
-- OnAddOnLoaded  --
-------------------------------------------------------------------------------------------------
function Medusa.OnAddOnLoaded(event, addonName)
    if addonName ~= Medusa.name then
        return
    end

    Medusa:Initialize(0, "")
end

-------------------------------------------------------------------------------------------------
-- OnPlayerCombatState  --
-------------------------------------------------------------------------------------------------
function Medusa.OnPlayerCombatState(event, inCombat)
    -- The ~= operator is "not equal to" in Lua.
    if inCombat ~= Medusa.inCombat then
        -- The player's state has changed. Update the stored state...
        Medusa.inCombat = inCombat
        Medusa.location = GetMapName()
        EVENT_MANAGER:UnregisterForUpdate('ExitDelay')
    end

    local zoneId = GetZoneId(GetUnitZoneIndex("player"))

    -- Check location and make action
    if inCombat then
        -- Show debug data
        if Medusa.debug then
            d('MD: Combat started')
        end

        -- Entering combat
        if zoneId == Medusa.TRIAL_CLOUDREST then
            Medusa.InitCloudrest()
        elseif zoneId == Medusa.TRIAL_SUNSPIRE then -- added only for debug so far
            Medusa.InitSunspire()
        else
            Medusa.StopAllCombatEvents()
        end
    else

        -- Show debug info
        if Medusa.debug then
            d('MD: Combat ended')
        end

        Medusa.exitCombat = tonumber(GetTimeStamp())
        EVENT_MANAGER:UnregisterForUpdate("PortalUpdate")
        EVENT_MANAGER:RegisterForUpdate('ExitDelay', 100, Medusa.QueueStopAllCombatEvents)
    end
end

-------------------------------------------------------------------------------------------------
-- Tracks player zone swaps and starts or ends logging
-------------------------------------------------------------------------------------------------
function Medusa.OnPlayerZoneChange(eventCode, zoneName, subZoneName, newSubzone, zoneId, subZoneId)
    if Medusa.debug then
        d('MD: zone changed to ' .. zoneName .. ' (' .. zoneId .. ')')
    end

    -- Checks if we are auto logging
    if Medusa.savedVariables.encountrerLog then
        if zoneId == Medusa.TRIAL_CLOUDREST and not Medusa.logStarted then
            Medusa.logStarted = true
            if Medusa.debug then
                d('MD: ' .. Medusa.Language.Settings_General_EncounterLog_Start)
            end
        elseif zoneId == Medusa.TRIAL_SUNSPIRE and not Medusa.logStarted then
            Medusa.logStarted = true
            if Medusa.debug then
                d('MD: ' .. Medusa.Language.Settings_General_EncounterLog_Start)
            end
        else
            Medusa.logStarted = false
        end
        SetEncounterLogEnabled(Medusa.logStarted)
    end
end

-------------------------------------------------------------------------------------------------
-- Adds combat queue for 5s after exit
-------------------------------------------------------------------------------------------------
function Medusa.QueueStopAllCombatEvents()
    local current = tonumber(GetTimeStamp())
    local remaining = current - Medusa.exitCombat

    -- Stop all combat timers, if more then 5 secods have passed
    if remaining > 5 then
        Medusa.StopAllCombatEvents()
        EVENT_MANAGER:UnregisterForUpdate('ExitDelay')
    end
end

-------------------------------------------------------------------------------------------------
-- Stop all events, when combat ends  --
-------------------------------------------------------------------------------------------------
function Medusa.StopAllCombatEvents()
    -- Reset trials
    Medusa.Cloudrest.Reset()
    Medusa.Sunspire.Reset()

    -- Stop events
    EVENT_MANAGER:UnregisterForEvent("BossesChanged")
end

-------------------------------------------------------------------------------------------------
-- Load language strings --
-------------------------------------------------------------------------------------------------
function Medusa.GetLanguage()
    local langCode = GetCVar('language.2')
    if langCode == "de" then
        return Medusa.LangDe
    elseif langCode == "fr" then
        return Medusa.LangFr
    end

    return Medusa.LangEn
end

-------------------------------------------------------------------------------------------------
--  Convert seconds to MM:SS format  --
-------------------------------------------------------------------------------------------------
function Medusa.SecondsToMinutes(remaining)
    -- Get minutes
    local mins = math.floor(remaining / 60)
    if mins < 0 then
        mins = "0"
    else
        mins = tostring(mins)
    end

    -- Get seconds
    local secs = remaining - (mins * 60)
    if (secs < 10) then
        secs = "0" .. tostring(secs)
    else
        secs = tostring(secs)
    end

    return mins .. ":" .. secs
end

-------------------------------------------------------------------------------------------------
-- Show/hide bars for debug options  --
-------------------------------------------------------------------------------------------------
function Medusa.DebugCommand(extra)
    -- Get parameter data
    local i = 0
    for k in string.gmatch(extra, "%S+") do
        i = i + 1
        if i == 2 then
            -- check if stop command given
            if k == "show" then
                Medusa.debug = true
                d('Medusa debug ON')
            end

            if k == "hide" then
                Medusa.debug = false
                d('Medusa debug OFF')
            end
        end
    end
end

-------------------------------------------------------------------------------------------------
-- Trigger specific ability for debug purposes  --
--
-- Usage: /md ability Gravechill
-------------------------------------------------------------------------------------------------
function Medusa.ActivateAbilityCommand(abilityName)
    if abilityName == "ability FocusedFire" then
        FocusedFireWindow:SetHidden(false)
        Medusa.Sunspire.abilities = Medusa.Sunspire.Yolnahkriin
        if Medusa.debug then
            d('MD: Event "Focused Fire" triggered')
        end
        Medusa.Sunspire.Events("Focused Fire")
    elseif abilityName == "ability Emberstorm" then
        EmberstormWindow:SetHidden(false)
        Medusa.Sunspire.abilities = Medusa.Sunspire.Yolnahkriin
        if Medusa.debug then
            d('MD: Event "Emberstorm" triggered')
        end
        Medusa.Sunspire.Events("Emberstorm")
    elseif abilityName == "ability Cataclysm" then
        CataclysmWindow:SetHidden(false)
        Medusa.Sunspire.abilities = Medusa.Sunspire.Yolnahkriin
        if Medusa.debug then
            d('MD: Event "Cataclysm" triggered')
        end
        Medusa.Sunspire.Events("Cataclysm")
    elseif abilityName == "ability FireStorm" then
        FireStormWindow:SetHidden(false)
        Medusa.Sunspire.abilities = Medusa.Sunspire.Nahviintaas
        if Medusa.debug then
            d('MD: Event "Fire Storm" triggered')
        end
        Medusa.Sunspire.Events("Fire Storm")
    elseif abilityName == "ability Gravechill" then
        Medusa.Sunspire.abilities = Medusa.Sunspire.Lokkestiiz
        if Medusa.debug then
            d('MD: Event "Gravechill 80%" triggered')
        end
        Medusa.stormFury = Medusa.Sunspire.abilities.StormFuryTimer_2
        Medusa.bossLanding = Medusa.Sunspire.abilities.BossLandingTimer_2
        Medusa.Sunspire.Events("Gravechill")
    elseif abilityName == "ability TimeShift" then
        Medusa.Sunspire.abilities = Medusa.Sunspire.Nahviintaas
        if Medusa.debug then
            d('MD: Event "Time Shift" triggered')
        end
        Medusa.Sunspire.Events("Time Shift")
    elseif abilityName == "ability FireBreath" then
        if Medusa.debug then
            d('MD: Announcement "Fire Breath" triggered')
        end
        Medusa.Sunspire.Announcements("Fire Breath")
    else
        if Medusa.debug then
            d('MD: No event found for ' .. abilityName)
        end
    end
end

-------------------------------------------------------------------------------------------------
-- Manage slash commands --
-------------------------------------------------------------------------------------------------
function Medusa.SlashCommands(extra)
    local i = 0
    -- Get general options
    for k in string.gmatch(extra, "%S+") do
        i = i + 1
        if i == 1 then
            if k == "debug" then
                Medusa.DebugCommand(extra)
            elseif k == "ability" then
                Medusa.ActivateAbilityCommand(extra)
            end
        end
    end
end

-------------------------------------------------------------------------------------------------
-- General events and commands --
-------------------------------------------------------------------------------------------------

EVENT_MANAGER:RegisterForEvent(Medusa.name, EVENT_PLAYER_COMBAT_STATE, Medusa.OnPlayerCombatState)
EVENT_MANAGER:RegisterForEvent(Medusa.name, EVENT_ADD_ON_LOADED, Medusa.OnAddOnLoaded)
SLASH_COMMANDS["/md"] = function(extra)
    Medusa.SlashCommands(extra)
end
