Medusa = Medusa or {}

-------------------------------------------------------------------------------------------------
-- Libraries --
-------------------------------------------------------------------------------------------------
local LAM = LibAddonMenu2

-------------------------------------------------------------------------------------------------
-- Create settings menu  --
-------------------------------------------------------------------------------------------------
function Medusa.CreateSettingsWindow()
    local panelData = {
        type = "panel",
        name = "Medusa",
        displayName = "Medusa Trial helper",
        author = "|c277ecdAaxc|r",
        version = Medusa.version,
        slashCommand = "/mdsettings",
        registerForRefresh = true,
        registerForDefaults = true,
    }
    local cntrlOptionsPanel = LAM:RegisterAddonPanel("Aaxc_Medusa", panelData)

    -- @TODO Move this into settins LUA for easier reading

    local optionsData = {
        {
            type = "header",
            name = Medusa.Language.Settings_General_Header,
        },
        {
            type = "checkbox",
            name = Medusa.Language.Settings_General_ShowVeteran,
            tooltip = Medusa.Language.Settings_General_ShowVeteran_Tooltip,
            default = true,
            getFunc = function() return Medusa.savedVariables.showVeteran end,
            setFunc = function(newValue)
                Medusa.savedVariables.showVeteran = newValue
            end,
        },
        {
            type = "checkbox",
            name = Medusa.Language.Settings_General_Debug,
            tooltip = Medusa.Language.Settings_General_Debug_Tooltip,
            default = false,
            getFunc = function() return Medusa.debug end,
            setFunc = function(newValue)
                Medusa.debug = newValue
                Medusa.savedVariables.debug = newValue
            end,
        },
        {
            type = "header",
            name = Medusa.Language.Settings_General_Trials,
        },
        {
            type = "description",
            text = Medusa.Language.Settings_General_Trials_Description,
        },
        Medusa.GetCloudrestSettings(),
        Medusa.GetSunspireSettings(),
    }

    LAM:RegisterOptionControls("Aaxc_Medusa", optionsData)
end
