Medusa = Medusa or {}

-------------------------------------------------------------------------------------------------
--  Retrieve Cloudrest settings  --
-------------------------------------------------------------------------------------------------
function Medusa.GetCloudrestSettings()
    return {
        type = "submenu",
        name = Medusa.Language.Settings_Cloudrest,
        tooltip = Medusa.Language.Settings_Cloudrest_Tooltips,
        controls = {
            {
                type = "checkbox",
                name = Medusa.Language.Settings_General_LockBar,
                tooltip = Medusa.Language.Settings_General_LockBar_Tooltip,
                getFunc = function() return Medusa.savedVariables.CloudrestLockBar end,
                setFunc = function(newValue)
                    Medusa.savedVariables.CloudrestLockBar = newValue
                    Medusa.CloudrestShowBars(not newValue)
                    Medusa.CloudrestUnLockBars(not newValue)
                end,
            },
            {
                type = "header",
                name = Medusa.Language.Settings_Cloudrest_Kite,
            },
            {
                type = "checkbox",
                name = Medusa.Language.Settings_Cloudrest_Kite_Show,
                tooltip = Medusa.Language.Settings_Cloudrest_Kite_Show_Tooltip,
                default = true,
                getFunc = function() return Medusa.savedVariables.kiteShow end,
                setFunc = function(newValue) Medusa.savedVariables.kiteShow = newValue end,
            },
            {
                type = "slider",
                name = Medusa.Language.Settings_General_Width,
                tooltip = Medusa.Language.Settings_General_Width_Tooltip,
                min = 200,
                max = 500,
                step = 1,
                default = 350,
                getFunc = function() return Medusa.savedVariables.kiteWidth end,
                setFunc = function(newValue)
                    Medusa.savedVariables.kiteWidth = newValue
                    Medusa.KiteSetBarSize(newValue, Medusa.savedVariables.kiteHeight)
                end,
            },
            {
                type = "slider",
                name = Medusa.Language.Settings_General_Height,
                tooltip = Medusa.Language.Settings_General_Height_Tooltip,
                min = 25,
                max = 50,
                step = 1,
                default = 35,
                getFunc = function() return Medusa.savedVariables.kiteHeight end,
                setFunc = function(newValue)
                    Medusa.savedVariables.kiteHeight = newValue
                    Medusa.KiteSetBarSize(Medusa.savedVariables.kiteWidth, newValue)
                end,
            },
            {
                type = "colorpicker",
                name = Medusa.Language.Settings_General_Color,
                tooltip = Medusa.Language.Settings_General_Color_Tooltip,
                getFunc = function() return unpack(Medusa.savedVariables.kiteColor) end,
                setFunc = function(r, g, b, a)
                    local alpha = KiteWindowStatusBar:GetAlpha()
                    Medusa.savedVariables.kiteColor = { r, g, b, a }
                    KiteWindowStatusBar:SetColor(r, g, b, a)
                    KiteWindowStatusBar:SetMinMax(0, 1)
                    KiteWindowStatusBar:SetValue(1)
                end,
            },
        },
    }
end
