Medusa = Medusa or {}

---------------------------------------------------
-- Cataclysm  --
---------------------------------------------------
function Medusa.Sunspire.ShowCataclysmBar()
    local current = tonumber(GetTimeStamp())

    -- Don't show, if not started. This prevents errors
    if Medusa.Sunspire.cataclysmStarted and Medusa.Sunspire.abilities.CataclysmDuration and Medusa.Sunspire.abilities.BossLanding then
        local endtime = tonumber(Medusa.Sunspire.cataclysmStarted) + tonumber(Medusa.Sunspire.abilities.CataclysmDuration) + tonumber(Medusa.Sunspire.abilities.BossLanding)
        local remaining = endtime - current

        if remaining > Medusa.Sunspire.abilities.BossLanding then
            local ongoingTime = remaining - Medusa.Sunspire.abilities.BossLanding
            local remainString = Medusa.SecondsToMinutes(ongoingTime)
            CataclysmWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.CataclysmDuration)
            CataclysmWindowStatusBar:SetValue(ongoingTime)
            CataclysmWindowStatusBar:SetColor(unpack(Medusa.savedVariables.cataclysmColor))
            CataclysmWindowLabel:SetText(Medusa.Language.Events_Sunspire_Cataclysm_Ongoing)
            CataclysmWindowLabelTime:SetText(remainString)
            CataclysmWindow:SetHidden(false)
        else
            local remainString = Medusa.SecondsToMinutes(remaining)
            CataclysmWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.BossLanding)
            CataclysmWindowStatusBar:SetValue(remaining)
            CataclysmWindowStatusBar:SetColor(unpack(Medusa.savedVariables.cataclysmColor))
            CataclysmWindowLabel:SetText(Medusa.Language.Events_Sunspire_Cataclysm_Boss_Soon)
            CataclysmWindowLabelTime:SetText(remainString)
            CataclysmWindow:SetHidden(false)
        end

        -- Exit and stop, when timer runs out
        if remaining < 1 then
            Medusa.Sunspire.cataclysmStarted = 0
            CataclysmWindow:SetHidden(true)
            CataclysmWindowStatusBar:SetMinMax(0, 1)
            CataclysmWindowStatusBar:SetValue(1)
            CataclysmWindowLabel:SetText(Medusa.Language.Events_Sunspire_Cataclysm)
            CataclysmWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaCataclysm")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaCataclysm")
    end
end
