Medusa = Medusa or {}

---------------------------------------------------
-- Emberstorm  --
---------------------------------------------------
function Medusa.Sunspire.ShowEmberstormBar()
    local current = tonumber(GetTimeStamp())

    -- Don't show, if not started. This prevents errors
    if Medusa.Sunspire.emberstormStarted and Medusa.Sunspire.abilities.EmberstormDuration and Medusa.Sunspire.abilities.EmberstormFrequency then
        local endtime = tonumber(Medusa.Sunspire.emberstormStarted) + tonumber(Medusa.Sunspire.abilities.EmberstormDuration) + tonumber(Medusa.Sunspire.abilities.EmberstormFrequency)
        local remaining = endtime - current

        if remaining > Medusa.Sunspire.abilities.EmberstormFrequency then
            local ongoingTime = remaining - Medusa.Sunspire.abilities.EmberstormFrequency
            local remainString = Medusa.SecondsToMinutes(ongoingTime)
            EmberstormWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.EmberstormDuration)
            EmberstormWindowStatusBar:SetValue(ongoingTime)
            EmberstormWindowStatusBar:SetColor(unpack(Medusa.savedVariables.emberstormColor))
            EmberstormWindowLabel:SetText(Medusa.Language.Events_Sunspire_Emberstorm_Ongoing)
            EmberstormWindowLabelTime:SetText(remainString)
            EmberstormWindow:SetHidden(false)
        else
            local remainString = Medusa.SecondsToMinutes(remaining)
            EmberstormWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.EmberstormFrequency)
            EmberstormWindowStatusBar:SetValue(remaining)
            EmberstormWindowStatusBar:SetColor(unpack(Medusa.savedVariables.emberstormColor))
            EmberstormWindowLabel:SetText(Medusa.Language.Events_Sunspire_Emberstorm_Soon)
            EmberstormWindowLabelTime:SetText(remainString)
            EmberstormWindow:SetHidden(false)
        end

        -- Exit and stop, when timer runs out
        if remaining < 1 then
            Medusa.Sunspire.emberstormStarted = 0
            EmberstormWindowStatusBar:SetMinMax(0, 1)
            EmberstormWindowStatusBar:SetValue(1)
            EmberstormWindowLabel:SetText(Medusa.Language.Events_Sunspire_Emberstorm)
            EmberstormWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaEmberstorm")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaEmberstorm")
    end
end

---------------------------------------------------
-- First emberstorm  --
---------------------------------------------------
function Medusa.Sunspire.ShowFirstEmberstormBar()
    local current = tonumber(GetTimeStamp())
    if Medusa.Sunspire.combatStart and Medusa.Sunspire.abilities.EmberstormFirst then
        local endtime = Medusa.Sunspire.combatStart + Medusa.Sunspire.abilities.EmberstormFirst
        local remaining = endtime - current

        if remaining > 0 then
            local remainString = Medusa.SecondsToMinutes(remaining)
            EmberstormWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.EmberstormFirst)
            EmberstormWindowStatusBar:SetValue(remaining)
            EmberstormWindowStatusBar:SetColor(unpack(Medusa.savedVariables.emberstormColor))
            EmberstormWindowLabel:SetText(Medusa.Language.Events_Sunspire_Emberstorm_Soon)
            EmberstormWindowLabelTime:SetText(remainString)
            EmberstormWindow:SetHidden(false)
        end

        -- Exit and stop, when timer runs out
        if remaining < 1 then
            Medusa.Sunspire.emberstormStarted = 0
            EmberstormWindowStatusBar:SetMinMax(0, 1)
            EmberstormWindowStatusBar:SetValue(1)
            EmberstormWindowLabel:SetText(Medusa.Language.Events_Sunspire_Emberstorm)
            EmberstormWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaEmberstorm")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaEmberstorm")
    end
end