Medusa = Medusa or {}

---------------------------------------------------
-- Fire Storm --
---------------------------------------------------
function Medusa.Sunspire.ShowFireStormBar()
    local current = tonumber(GetTimeStamp())

    -- Don't show, if not started. This prevents errors
    if Medusa.Sunspire.fireStormStarted and Medusa.Sunspire.abilities.FireStormDuration and Medusa.Sunspire.abilities.ShatterStoneDuration then
        local endtime = tonumber(Medusa.Sunspire.fireStormStarted) + tonumber(Medusa.Sunspire.abilities.FireStormDuration) + tonumber(Medusa.Sunspire.abilities.ShatterStoneDuration)
        local remaining = endtime - current
        local remainString = Medusa.SecondsToMinutes(remaining)

        local ongoingTime = Medusa.Sunspire.fireStormStarted + Medusa.Sunspire.abilities.FireStormDuration - current
        if ongoingTime > 0 then
            FireStormWindowFinishBar:SetHidden(false)
            FireStormWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.FireStormDuration)
            FireStormWindowStatusBar:SetValue(ongoingTime)
            FireStormWindowLabel:SetText(Medusa.Language.Events_Sunspire_FireStorm_Ongoing)
            FireStormWindowFinishBar:SetMinMax(0, Medusa.Sunspire.abilities.fireStormTimer)
            FireStormWindowFinishBar:SetValue(Medusa.Sunspire.abilities.fireStormTimer)
            FireStormWindow:SetHidden(false)
        else
            FireStormWindowStatusBar:SetMinMax(0, 1)
            FireStormWindowStatusBar:SetValue(0)
            FireStormWindowFinishBar:SetMinMax(0, Medusa.Sunspire.abilities.fireStormTimer)
            FireStormWindowFinishBar:SetValue(remaining)
            FireStormWindowLabel:SetText(Medusa.Language.Events_Sunspire_FireStorm_Ongoing_Finishing)
        end

        FireStormWindowLabelTime:SetText(remainString)
        FireStormWindow:SetHidden(false)

        if remaining < 1 then
            FireStormWindow:SetHidden(true)
            Medusa.Sunspire.fireStormStarted = 0
            FireStormWindowStatusBar:SetMinMax(0, 1)
            FireStormWindowStatusBar:SetValue(1)
            FireStormWindowFinishBar:SetMinMax(0, 1)
            FireStormWindowFinishBar:SetValue(1)
            FireStormWindowLabel:SetText(Medusa.Language.Events_Sunspire_FireStorm)
            FireStormWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaFireStorm")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaFireStorm")
    end
end
