Medusa = Medusa or {}

---------------------------------------------------
-- Focused fire  --
---------------------------------------------------
function Medusa.Sunspire.ShowFocusedFireBar()
    local current = tonumber(GetTimeStamp())

    -- Don't show, if not started. This prevents errors
    if Medusa.Sunspire.focusedFireStarted and Medusa.Sunspire.abilities.FocusedFireDuration then
        local endtime = tonumber(Medusa.Sunspire.focusedFireStarted) + tonumber(Medusa.Sunspire.abilities.FocusedFireDuration)

        local ongoingTime = endtime - current
        local remaining = ongoingTime + tonumber(Medusa.Sunspire.abilities.FocusedFireTimer)

        if ongoingTime > 0 then
            local remainString = Medusa.SecondsToMinutes(ongoingTime)
            FocusedFireWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.FocusedFireDuration)
            FocusedFireWindowStatusBar:SetValue(ongoingTime)
            FocusedFireWindowStatusBar:SetColor(unpack(Medusa.savedVariables.focusedFireColor))
            FocusedFireWindowLabel:SetText(Medusa.Language.Events_Sunspire_FocusedFire_Ongoing)
            FocusedFireWindowLabelTime:SetText(remainString)
            FocusedFireWindow:SetHidden(false)
        else
            local remainString = Medusa.SecondsToMinutes(remaining)
            FocusedFireWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.FocusedFireTimer)
            FocusedFireWindowStatusBar:SetValue(remaining)
            FocusedFireWindowStatusBar:SetColor(unpack(Medusa.savedVariables.focusedFireColor))
            FocusedFireWindowLabel:SetText(Medusa.Language.Events_Sunspire_Next_FocusedFire)
            FocusedFireWindowLabelTime:SetText(remainString)
            FocusedFireWindow:SetHidden(false)
        end

        -- Exit and stop, when timer runs out
        if remaining < 1 then
            Medusa.Sunspire.focusedFireStarted = 0
            FocusedFireWindowStatusBar:SetMinMax(0, 1)
            FocusedFireWindowStatusBar:SetValue(1)
            FocusedFireWindowLabel:SetText(Medusa.Language.Events_Sunspire_Next_FocusedFire_Soon)
            FocusedFireWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaFocusedFire")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaFocusedFire")
    end
end

---------------------------------------------------
-- First focused fire  --
---------------------------------------------------
function Medusa.Sunspire.ShowFirstFocusedFireBar()
    local current = tonumber(GetTimeStamp())
    if Medusa.Sunspire.combatStart and Medusa.Sunspire.abilities.FocusedFireFirst then
        local endtime = Medusa.Sunspire.combatStart + Medusa.Sunspire.abilities.FocusedFireFirst
        local remaining = endtime - current

        if remaining > 0 then
            local remainString = Medusa.SecondsToMinutes(remaining)
            FocusedFireWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.FocusedFireFirst)
            FocusedFireWindowStatusBar:SetValue(remaining)
            FocusedFireWindowStatusBar:SetColor(unpack(Medusa.savedVariables.focusedFireColor))
            FocusedFireWindowLabel:SetText(Medusa.Language.Events_Sunspire_Next_FocusedFire)
            FocusedFireWindowLabelTime:SetText(remainString)
            FocusedFireWindow:SetHidden(false)
        end

        -- Exit and stop, when timer runs out
        if remaining < 1 then
            Medusa.Sunspire.focusedFireStarted = 0
            FocusedFireWindowStatusBar:SetMinMax(0, 1)
            FocusedFireWindowStatusBar:SetValue(1)
            FocusedFireWindowLabel:SetText(Medusa.Language.Events_Sunspire_Next_FocusedFire_Soon)
            FocusedFireWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaFocusedFire")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaFocusedFire")
    end
end