Medusa = Medusa or {}

---------------------------------------------------
-- Gravechill  --
---------------------------------------------------
function Medusa.Sunspire.ShowGravechillBar()
    local current = tonumber(GetTimeStamp())

    -- Don't show, if not started. This prevents errors
    if Medusa.Sunspire.gravechillStarted and Medusa.Sunspire.abilities.StormFuryDuration and Medusa.stormFury and Medusa.bossLanding then
        -- Set global vars
        local stormFury = Medusa.stormFury
        local bossLanding = Medusa.bossLanding

        local endtime = tonumber(Medusa.Sunspire.gravechillStarted) + tonumber(bossLanding)
        local remaining = endtime - current
        local onGoingTime = current - tonumber(Medusa.Sunspire.gravechillStarted)

        if onGoingTime < stormFury then
            local stormFuryTime = stormFury - onGoingTime
            local remainString = Medusa.SecondsToMinutes(stormFuryTime)
            CataclysmWindowStatusBar:SetMinMax(0, stormFury)
            CataclysmWindowStatusBar:SetValue(stormFuryTime)
            CataclysmWindowStatusBar:SetColor(unpack(Medusa.savedVariables.gravechillColor))
            CataclysmWindowLabel:SetText(Medusa.Language.Events_Sunspire_StormFury)
            CataclysmWindowLabelTime:SetText(remainString)
            CataclysmWindow:SetHidden(false)
        elseif onGoingTime < (stormFury + tonumber(Medusa.Sunspire.abilities.StormFuryDuration)) then
            local stormFuryTime = (stormFury + Medusa.Sunspire.abilities.StormFuryDuration) - onGoingTime
            local remainString = Medusa.SecondsToMinutes(stormFuryTime)
            CataclysmWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.StormFuryDuration)
            CataclysmWindowStatusBar:SetValue(stormFuryTime)
            CataclysmWindowStatusBar:SetColor(unpack(Medusa.savedVariables.gravechillColor))
            CataclysmWindowLabel:SetText(Medusa.Language.Events_Sunspire_StormFury_Ongoing)
            CataclysmWindowLabelTime:SetText(remainString)
            CataclysmWindow:SetHidden(false)
        else
            local remainString = Medusa.SecondsToMinutes(remaining)
            CataclysmWindowStatusBar:SetMinMax(0, bossLanding)
            CataclysmWindowStatusBar:SetValue(remaining)
            CataclysmWindowStatusBar:SetColor(unpack(Medusa.savedVariables.gravechillColor))
            CataclysmWindowLabel:SetText(Medusa.Language.Events_Sunspire_Gravechill_Boss_Soon)
            CataclysmWindowLabelTime:SetText(remainString)
            CataclysmWindow:SetHidden(false)
        end

        -- Exit and stop, when timer runs out
        if remaining < 1 then
            Medusa.Sunspire.gravechillStarted = 0
            CataclysmWindow:SetHidden(true)
            CataclysmWindowStatusBar:SetMinMax(0, 1)
            CataclysmWindowStatusBar:SetValue(1)
            CataclysmWindowLabel:SetText(Medusa.Language.Events_Sunspire_Gravechill)
            CataclysmWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaGravechill")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaGravechill")
    end
end
