Medusa = Medusa or {}

---------------------------------------------------
-- Time Shift  --
---------------------------------------------------
function Medusa.Sunspire.ShowTimeShiftBar()
    local current = tonumber(GetTimeStamp())

    -- Don't show, if not started. This prevents errors
    if Medusa.Sunspire.timeShiftStarted and Medusa.Sunspire.abilities.TimeShiftDuration then
        local endtime = tonumber(Medusa.Sunspire.timeShiftStarted) + tonumber(Medusa.Sunspire.abilities.TimeShiftDuration)
        local remaining = endtime - current

        if remaining > 0 then
            local ongoingTime = remaining
            local remainString = Medusa.SecondsToMinutes(ongoingTime)
            TimeShiftWindowStatusBar:SetMinMax(0, Medusa.Sunspire.abilities.TimeShiftDuration)
            TimeShiftWindowStatusBar:SetValue(ongoingTime)
            TimeShiftWindowStatusBar:SetColor(unpack(Medusa.savedVariables.timeShiftColor))
            TimeShiftWindowLabel:SetText(Medusa.Language.Events_Sunspire_TimeShift_Ongoing)
            TimeShiftWindowLabelTime:SetText(remainString)
            TimeShiftWindow:SetHidden(false)
        end

        -- Exit and stop, when timer runs out
        if remaining < 1 then
            Medusa.Sunspire.timeShiftStarted = 0
            TimeShiftWindow:SetHidden(true)
            TimeShiftWindowStatusBar:SetMinMax(0, 1)
            TimeShiftWindowStatusBar:SetValue(1)
            TimeShiftWindowLabel:SetText(Medusa.Language.Events_Sunspire_TimeShift)
            TimeShiftWindowLabelTime:SetText("")
            EVENT_MANAGER:UnregisterForUpdate("MedusaTimeShift")
        end
    else
        EVENT_MANAGER:UnregisterForUpdate("MedusaTimeShift")
    end
end
