Medusa = Medusa or {}

-------------------------------------------------------------------------------------------------
--  Retrieve Sunspire settings  --
-------------------------------------------------------------------------------------------------
function Medusa.GetSunspireSettings()
    return {
        type = "submenu",
        name = Medusa.Language.Settings_Sunspire,
        tooltip = Medusa.Language.Settings_Sunspire_Tooltips,
        controls = {
            {
                type = "checkbox",
                name = Medusa.Language.Settings_General_LockBar,
                tooltip = Medusa.Language.Settings_General_LockBar_Tooltip,
                getFunc = function() return Medusa.savedVariables.SunspireLockBar end,
                setFunc = function(newValue)
                    Medusa.savedVariables.SunspireLockBar = newValue
                    Medusa.Sunspire.ShowBars(not newValue)
                    Medusa.Sunspire.UnLockBars(not newValue)
                end,
            },
            {
                type = "submenu",
                name = Medusa.Language.Settings_Sunspire_Lokkestiiz,
                tooltip = 'Boss: ' .. Medusa.Language.Settings_Sunspire_Lokkestiiz,
                controls = {
                    {
                        type = "header",
                        name = Medusa.Language.Events_Sunspire_Gravechill,
                    },
                    {
                        type = "checkbox",
                        name = Medusa.Language.Settings_Sunspire_Gravechill_Show,
                        tooltip = Medusa.Language.Settings_Sunspire_Gravechill_Show_Tooltip,
                        default = true,
                        getFunc = function() return Medusa.savedVariables.gravechillShow end,
                        setFunc = function(newValue) Medusa.savedVariables.gravechillShow = newValue end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Width,
                        tooltip = Medusa.Language.Settings_General_Width_Tooltip,
                        min = 200,
                        max = 500,
                        step = 1,
                        default = 350,
                        getFunc = function() return Medusa.savedVariables.gravechillWidth end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.gravechillWidth = newValue
                            Medusa.Sunspire.SetBarSize('Gravechill', newValue, Medusa.savedVariables.gravechillHeight)
                        end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Height,
                        tooltip = Medusa.Language.Settings_General_Height_Tooltip,
                        min = 25,
                        max = 50,
                        step = 1,
                        default = 35,
                        getFunc = function() return Medusa.savedVariables.gravechillHeight end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.gravechillHeight = newValue
                            Medusa.Sunspire.SetBarSize('Gravechill', Medusa.savedVariables.gravechillWidth, newValue)
                        end,
                    },
                    {
                        type = "colorpicker",
                        name = Medusa.Language.Settings_General_Color,
                        tooltip = Medusa.Language.Settings_General_Color_Tooltip,
                        getFunc = function() return unpack(Medusa.savedVariables.gravechillColor) end,
                        setFunc = function(r, g, b, a)
                            Medusa.savedVariables.gravechillColor = { r, g, b, a }
                            Medusa.Sunspire.SetBarColor('Gravechill', r, g, b, a)
                            Medusa.Sunspire.ShowFullBar('Gravechill')
                        end,
                    },
                },
            },
            {
                type = "submenu",
                name = Medusa.Language.Settings_Sunspire_Yolnahkriin,
                tooltip = 'Boss: ' .. Medusa.Language.Settings_Sunspire_Yolnahkriin,
                controls = {
                    {
                        type = "header",
                        name = Medusa.Language.Events_Sunspire_FocusedFire,
                    },
                    {
                        type = "checkbox",
                        name = Medusa.Language.Settings_Sunspire_FocusedFire_Show,
                        tooltip = Medusa.Language.Settings_Sunspire_FocusedFire_Show_Tooltip,
                        default = true,
                        getFunc = function() return Medusa.savedVariables.focusedFireShow end,
                        setFunc = function(newValue) Medusa.savedVariables.focusedFireShow = newValue end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Width,
                        tooltip = Medusa.Language.Settings_General_Width_Tooltip,
                        min = 200,
                        max = 500,
                        step = 1,
                        default = 350,
                        getFunc = function() return Medusa.savedVariables.focusedFireWidth end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.focusedFireWidth = newValue
                            Medusa.Sunspire.SetBarSize('FocusedFire', newValue, Medusa.savedVariables.focusedFireHeight)
                        end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Height,
                        tooltip = Medusa.Language.Settings_General_Height_Tooltip,
                        min = 25,
                        max = 50,
                        step = 1,
                        default = 35,
                        getFunc = function() return Medusa.savedVariables.focusedFireHeight end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.focusedFireHeight = newValue
                            Medusa.Sunspire.SetBarSize('FocusedFire', Medusa.savedVariables.focusedFireWidth, newValue)
                        end,
                    },
                    {
                        type = "colorpicker",
                        name = Medusa.Language.Settings_General_Color,
                        tooltip = Medusa.Language.Settings_General_Color_Tooltip,
                        getFunc = function() return unpack(Medusa.savedVariables.focusedFireColor) end,
                        setFunc = function(r, g, b, a)
                            Medusa.savedVariables.focusedFireColor = { r, g, b, a }
                            Medusa.Sunspire.SetBarColor('FocusedFire', r, g, b, a)
                            Medusa.Sunspire.ShowFullBar('FocusedFire')
                        end,
                    },
                    {
                        type = "header",
                        name = Medusa.Language.Events_Sunspire_Emberstorm,
                    },
                    {
                        type = "checkbox",
                        name = Medusa.Language.Settings_Sunspire_Emberstorm_Show,
                        tooltip = Medusa.Language.Settings_Sunspire_Emberstorm_Show_Tooltip,
                        default = true,
                        getFunc = function() return Medusa.savedVariables.emberstormShow end,
                        setFunc = function(newValue) Medusa.savedVariables.emberstormShow = newValue end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Width,
                        tooltip = Medusa.Language.Settings_General_Width_Tooltip,
                        min = 200,
                        max = 500,
                        step = 1,
                        default = 350,
                        getFunc = function() return Medusa.savedVariables.emberstormWidth end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.emberstormWidth = newValue
                            Medusa.Sunspire.SetBarSize('Emberstorm', newValue, Medusa.savedVariables.emberstormHeight)
                        end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Height,
                        tooltip = Medusa.Language.Settings_General_Height_Tooltip,
                        min = 25,
                        max = 50,
                        step = 1,
                        default = 35,
                        getFunc = function() return Medusa.savedVariables.emberstormHeight end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.emberstormHeight = newValue
                            Medusa.Sunspire.SetBarSize('Emberstorm', Medusa.savedVariables.emberstormWidth, newValue)
                        end,
                    },
                    {
                        type = "colorpicker",
                        name = Medusa.Language.Settings_General_Color,
                        tooltip = Medusa.Language.Settings_General_Color_Tooltip,
                        getFunc = function() return unpack(Medusa.savedVariables.emberstormColor) end,
                        setFunc = function(r, g, b, a)
                            Medusa.savedVariables.emberstormColor = { r, g, b, a }
                            Medusa.Sunspire.SetBarColor('Emberstorm', r, g, b, a)
                            Medusa.Sunspire.ShowFullBar('Emberstorm')
                        end,
                    },
                    {
                        type = "header",
                        name = Medusa.Language.Events_Sunspire_Cataclysm,
                    },
                    {
                        type = "checkbox",
                        name = Medusa.Language.Settings_Sunspire_Cataclysm_Show,
                        tooltip = Medusa.Language.Settings_Sunspire_Cataclysm_Show_Tooltip,
                        default = true,
                        getFunc = function() return Medusa.savedVariables.cataclysmShow end,
                        setFunc = function(newValue) Medusa.savedVariables.cataclysmShow = newValue end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Width,
                        tooltip = Medusa.Language.Settings_General_Width_Tooltip,
                        min = 200,
                        max = 500,
                        step = 1,
                        default = 350,
                        getFunc = function() return Medusa.savedVariables.cataclysmWidth end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.cataclysmWidth = newValue
                            Medusa.Sunspire.SetBarSize('Cataclysm', newValue, Medusa.savedVariables.cataclysmHeight)
                        end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Height,
                        tooltip = Medusa.Language.Settings_General_Height_Tooltip,
                        min = 25,
                        max = 50,
                        step = 1,
                        default = 35,
                        getFunc = function() return Medusa.savedVariables.cataclysmHeight end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.cataclysmHeight = newValue
                            Medusa.Sunspire.SetBarSize('Cataclysm', Medusa.savedVariables.cataclysmWidth, newValue)
                        end,
                    },
                    {
                        type = "colorpicker",
                        name = Medusa.Language.Settings_General_Color,
                        tooltip = Medusa.Language.Settings_General_Color_Tooltip,
                        getFunc = function() return unpack(Medusa.savedVariables.cataclysmColor) end,
                        setFunc = function(r, g, b, a)
                            Medusa.savedVariables.cataclysmColor = { r, g, b, a }
                            Medusa.Sunspire.SetBarColor('Cataclysm', r, g, b, a)
                            Medusa.Sunspire.ShowFullBar('Cataclysm')
                        end,
                    },
                },
            },
            {
                type = "submenu",
                name = Medusa.Language.Settings_Sunspire_Nahviintaas,
                tooltip = 'Boss: ' .. Medusa.Language.Settings_Sunspire_Nahviintaas,
                controls = {
                    {
                        type = "header",
                        name = Medusa.Language.Events_Sunspire_FireStorm,
                    },
                    {
                        type = "checkbox",
                        name = Medusa.Language.Settings_Sunspire_FocusedFire_Show,
                        tooltip = Medusa.Language.Settings_Sunspire_FocusedFire_Show_Tooltip,
                        default = true,
                        getFunc = function() return Medusa.savedVariables.fireStormShow end,
                        setFunc = function(newValue) Medusa.savedVariables.fireStormShow = newValue end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Width,
                        tooltip = Medusa.Language.Settings_General_Width_Tooltip,
                        min = 200,
                        max = 500,
                        step = 1,
                        default = 350,
                        getFunc = function() return Medusa.savedVariables.fireStormWidth end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.fireStormWidth = newValue
                            Medusa.Sunspire.SetBarSize('FireStorm', newValue, Medusa.savedVariables.fireStormHeight)
                        end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Height,
                        tooltip = Medusa.Language.Settings_General_Height_Tooltip,
                        min = 25,
                        max = 50,
                        step = 1,
                        default = 35,
                        getFunc = function() return Medusa.savedVariables.fireStormHeight end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.fireStormHeight = newValue
                            Medusa.Sunspire.SetBarSize('FireStorm', Medusa.savedVariables.fireStormWidth, newValue)
                        end,
                    },
                    {
                        type = "header",
                        name = Medusa.Language.Events_Sunspire_TimeShift,
                    },
                    {
                        type = "checkbox",
                        name = Medusa.Language.Settings_Sunspire_TimeShift_Show,
                        tooltip = Medusa.Language.Settings_Sunspire_TimeShift_Show_Tooltip,
                        default = true,
                        getFunc = function() return Medusa.savedVariables.timeShiftShow end,
                        setFunc = function(newValue) Medusa.savedVariables.timeShiftShow = newValue end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Width,
                        tooltip = Medusa.Language.Settings_General_Width_Tooltip,
                        min = 200,
                        max = 500,
                        step = 1,
                        default = 350,
                        getFunc = function() return Medusa.savedVariables.timeShiftWidth end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.timeShiftWidth = newValue
                            Medusa.Sunspire.SetBarSize('TimeShift', newValue, Medusa.savedVariables.timeShiftHeight)
                        end,
                    },
                    {
                        type = "slider",
                        name = Medusa.Language.Settings_General_Height,
                        tooltip = Medusa.Language.Settings_General_Height_Tooltip,
                        min = 25,
                        max = 50,
                        step = 1,
                        default = 35,
                        getFunc = function() return Medusa.savedVariables.timeShiftHeight end,
                        setFunc = function(newValue)
                            Medusa.savedVariables.timeShiftHeight = newValue
                            Medusa.Sunspire.SetBarSize('TimeShift', Medusa.savedVariables.timeShiftWidth, newValue)
                        end,
                    },
                    {
                        type = "colorpicker",
                        name = Medusa.Language.Settings_General_Color,
                        tooltip = Medusa.Language.Settings_General_Color_Tooltip,
                        getFunc = function() return unpack(Medusa.savedVariables.timeShiftColor) end,
                        setFunc = function(r, g, b, a)
                            Medusa.savedVariables.timeShiftColor = { r, g, b, a }
                            Medusa.Sunspire.SetBarColor('TimeShift', r, g, b, a)
                            Medusa.Sunspire.ShowFullBar('TimeShift')
                        end,
                    },
                },
            },
        },
    }
end
